mscorlib 2.0.0.0 4.0.0.0 System.Enum

The enumeration specifies the behavior of a method, type, or assembly within a constrained execution region (CER). Use one of the three available values to indicate that the entity will succeed, has no knowledge of a CER, or might (deterministically) be able to report success or failure.

A CER provides guarantees that the region of code will execute uninterrupted even if an asynchronous exception such as an aborted thread out-of-memory exception, or stack overflow is raised.

Specifies a method's behavior when called within a constrained execution region.

- Field
  2.0.0.0
  4.0.0.0
  System.Runtime.ConstrainedExecution.Cer

  In the face of exceptional conditions, the method might fail. In this case, the method will report back to the calling method whether it succeeded or failed. The method must have a CER around the method body to ensure that it can report the return value.

- Field
  2.0.0.0
  4.0.0.0
  System.Runtime.ConstrainedExecution.Cer

  In the face of exceptional conditions the method might fail.

  The method might or might not report that it failed (it is non-deterministic).

  The method is not written with CERs in mind (which is the most likely scenario).

  If a method, type, or assembly is not explicitly marked to succeed, it is implicitly marked as Cer.None.

  The method, type, or assembly has no concept of a CER. It does not take advantage of CER guarantees. This implies the following:

- Field
  2.0.0.0
  4.0.0.0
  System.Runtime.ConstrainedExecution.Cer

  In the face of exceptional conditions, the method is guaranteed to succeed. You should always construct a CER around the method that is called, even when it is called from within a non-CER region. A method is successful if it accomplishes what is intended. For example, marking with ReliabilityContractAttribute(Cer.Success) implies that when it is run under a CER, it always returns a count of the number of elements in the and it can never leave the internal fields in an undetermined state.